/* $Id: e2_command.h 1856 2006-04-24 12:51:28Z tpgww $
 * 
 * Copyright (C) 2004-2005 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef E2_COMMAND_H
#define E2_COMMAND_H

#include "emelfm2.h"
#include "e2_output.h"

typedef enum
{
	E2_COMMAND_RANGE_DEFAULT,
	E2_COMMAND_RANGE_FILE_ACTION,
	E2_COMMAND_RANGE_FILE_OPERATION,
	E2_COMMAND_RANGE_SUBSHELL,
	E2_COMMAND_RANGE_CUSTOM
} E2_CommandRange;

typedef struct _E2_CommandRuntime
{
	guint pid;
	gchar *pidstr;
	gchar *command;
	gint exit;
	gboolean start;
	gboolean end;
	gboolean show;
	GIOChannel *ioin;
	gboolean closed;
	//the output data to use for this command when running in a non-focused tab
	E2_OutputTabRuntime *background_tab;
	//=background_tab or &app.tab if this command is currently running in the focused tab
	E2_OutputTabRuntime *current_tab;
} E2_CommandRuntime;

gboolean e2_command_find_process (guint pid);
gint e2_command_run (gchar *command, E2_CommandRange range);
gint e2_command_count_children (void);
guint e2_command_find_last_child (void);
void e2_command_list_children (gpointer data);
void e2_command_retab_children (E2_OutputTabRuntime *currenttab,
	E2_OutputTabRuntime *replacetab);
void e2_command_retab2_children (E2_OutputTabRuntime *currenttab,
	E2_OutputTabRuntime *replacetab);
gboolean e2_command_kill_child (guint pid);
void e2_command_output_help (void);
void e2_command_actions_register (void);
void e2_command_options_register (void);

#endif //ndef E2_COMMAND_H
