/* $Id: e2_cl_option.h 1870 2006-04-27 08:58:49Z tpgww $
 * 
 * Copyright (C) 2003-2005 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef E2_CL_OPTION_H
#define E2_CL_OPTION_H

#include "emelfm2.h"

typedef struct _E2_CommandLineOptions
{
	gchar *pane1_path;
	gchar *pane2_path;
	gchar *config_dir;	//utf-8 string, no trailing /
	gchar *trash_dir;
	gchar *encoding;
	gchar *fallback_encoding;
	gchar **overrides;
#ifdef DEBUG_MESSAGES
	gint debug_level;
#endif
	gboolean no_detach;
	gboolean verbose;
	gboolean suppress_gtk_output;
	gboolean ignore_problems;
	GList *option_overrides;
	GList *startup_commands;
} E2_CommandLineOptions;

void e2_cl_option_process (int argc, char *argv[]);

E2_CommandLineOptions e2_cl_options;

#endif //ndef E2_CL_OPTION_H
