/* $Id: e2_view_dialog.h 1825 2006-04-08 12:31:49Z tpgww $
 * 
 * Copyright (C) 2004-2006 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef E2_VIEW_DIALOG_H
#define E2_VIEW_DIALOG_H

//include redo capability
//#define E2_REDO_ENABLED

//this struct is used for viewing and editing, to enable shared functions
typedef struct _E2_ViewDialogRuntime
{
	GtkWidget *dialog;
	GtkWidget *textview;
	GtkTextBuffer *textbuffer;
	gchar *filepath;
	gint window_width;
	gint window_height;
	guint idle_id;
	gboolean textwrap;
#ifdef E2_TRANSIENTKEYS
	gchar *key_binding;	//name of key-binding category
#endif
	//search things
	GtkWidget *panel;
	GtkWidget *combo;
	GtkWidget *info_label;
	GtkWidget *hidebtn;
	GtkWidget *findbtn;
	GList *history;
	gint history_cur;
	//edit things
	GtkWidget *replacebtn;
	GtkWidget *savebtn;
	GtkWidget *combo2;	//replacements
	GtkWidget *replacebar; //for hiding
	gint linebreak;	//type of line-separator in loaded file, 10, 13 or 23 (=CR+lF)
	const gchar *charset;	//name of file's character encoding (for internal conversion)
	GList *rephistory;
	gint rephistory_cur;
	//all search dialogs in session use same values for these
	//hence static
//	gboolean show_last;
//	gboolean case_sensitive;
//	gboolean search_backward;
//	gboolean search_wrap;
} E2_ViewDialogRuntime;

typedef struct E2_ViewHistory_
{
	gchar *filepath;	//utf8 string with path of a viewed item
	guint topline;	//buffer y coordinate of top visible row when internal viewer was closed
} E2_ViewHistory;

//FIXME location of these
void e2_edit_dialog_create (gchar *filename);
gboolean e2_edit_dialog_reopen (gpointer action_data, gpointer rt_data);
void e2_edit_dialog_save_selected (GtkTextBuffer *buffer, GtkWidget *parent);

//functions shared between view & edit dialogs
gboolean e2_view_dialog_read_text (E2_ViewDialogRuntime *rt);
void e2_view_dialog_set_menu_position (GtkWidget *menu,
	gint *x, gint *y, gboolean *push_in, E2_ViewDialogRuntime *rt);
void e2_view_dialog_update_combo (GtkWidget *combo);
gboolean e2_view_dialog_combokey_cb (GtkWidget *entry,
	GdkEventKey *event, E2_ViewDialogRuntime *rt);
void e2_view_dialog_toggled (GtkWidget *button, gboolean *store);
GtkWidget *e2_view_dialog_create_searchbar (E2_ViewDialogRuntime *rt);
gboolean e2_view_dialog_search (gboolean first, gboolean incremental,
	E2_ViewDialogRuntime *rt);
void e2_view_dialog_destroy (E2_ViewDialogRuntime *rt);
void e2_view_dialog_show_atlast (gchar *filepath, E2_ViewDialogRuntime *rt);

gboolean e2_edit_dialog_key_press_cb (GtkWidget *textview, 
	GdkEventKey *event, E2_ViewDialogRuntime *rt);

void e2_view_dialog_show (gchar *filename);
void e2_view_dialog_actions_register ();
void e2_view_dialog_options_register ();
#endif //ndef E2_VIEW_DIALOG_H
