/* $Id: e2_textiter.h 762 2005-05-13 04:00:38Z tpgww $
 * 
 *  Copyright (C) 2000, 2002 Paolo Maggi 
 *  Copyright (C) 2002, 2003 Jeroen Zwartepoorte
 *
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef __GTK_SOURCE_ITER_H__
#define __GTK_SOURCE_ITER_H__

#include <gtk/gtktextiter.h>

G_BEGIN_DECLS

typedef enum
{
	GTK_SOURCE_SEARCH_VISIBLE_ONLY,
	GTK_SOURCE_SEARCH_TEXT_ONLY,
	GTK_SOURCE_SEARCH_CASE_INSENSITIVE
	/* Possible future plans: SEARCH_REGEXP */
} GtkSourceSearchFlags;

gboolean e2_iter_forward_search (const GtkTextIter *iter,
						 const gchar         *str,
						 GtkSourceSearchFlags flags,
						 GtkTextIter         *match_start,
						 GtkTextIter         *match_end,
						 const GtkTextIter   *limit);

gboolean e2_iter_backward_search (const GtkTextIter *iter,
						 const gchar         *str,
						 GtkSourceSearchFlags flags,
						 GtkTextIter         *match_start,
						 GtkTextIter         *match_end,
						 const GtkTextIter   *limit);

G_END_DECLS

#endif /* __GTK_SOURCE_ITER_H__ */
